#include "DialogueBase.h"
#include <stdio.h>

CDialogueBase::CDialogueBase()
{
	Head = NULL;
}

CDialogueBase::~CDialogueBase()
{
	while(Head)
	{
		DialogueBaseHolder *Next = Head->Next;
		if(Head->AutoRelease) delete Head->Data;
		delete Head;
		Head = Next;
	}
}

bool CDialogueBase::Message(DialogueMessage *Msg)
{
	if(Msg->Type == DialogueMessage::DOTASK) return false; /* DOTASK is not propagated */

	DialogueBaseHolder *p = Head;
	bool result = false;
	while(p)
	{
		result |= p->Data->Message(Msg);
		p = p->Next;
	}
	return result;
}

void CDialogueBase::AddWidget(CDialogueBase *d, bool AutoRelease)
{
	DialogueBaseHolder *n = new DialogueBaseHolder;
	n->Data = d;
	n->AutoRelease = AutoRelease;
	n->Next = Head;
	Head = n;
}

void CDialogueBase::RemoveWidget(CDialogueBase *db)
{
	DialogueBaseHolder **d = &Head;
	while(*d)
	{
		if((*d)->Data == db)
		{
			DialogueBaseHolder *Next = (*d)->Next;
			delete *d;
			*d = Next;
			return;
		}
		d = &(*d)->Next;
	}
}
