#ifndef __DIALOGUEBASE_H
#define __DIALOGUEBASE_H

struct DialogueMessage
{
	enum {DRAW, CLICK, KEYPRESS, MOUSEMOVE, SCROLL, ENTER, EXIT, DOTASK} Type;
	float x, y;
	int Buttons;
	union
	{
		int Key;			/* low 16 bits unicode, high rest "scancode" */
		int ClickChange;	/* which buttons have changed for a click event */
		int Scroll;			/* quantity of scroll for a scroll event */
		struct
		{
			int Num;
			int Data;
			void *Ptr;
		} Task;
	} Data;
};

class CDialogueBase
{
	public:
		virtual ~CDialogueBase();
		CDialogueBase();

		void AddWidget(CDialogueBase *, bool AutoRelease = false);
		void RemoveWidget(CDialogueBase *);

		virtual bool Message(DialogueMessage *Msg);

	private:
		struct DialogueBaseHolder
		{
			CDialogueBase *Data;
			bool AutoRelease;
			DialogueBaseHolder *Next;
		} *Head;
};

#endif
