#ifndef __GLFOUNDATION_H
#define __GLFOUNDATION_H

#include "SDL_opengl.h"

extern float ScrW, ScrH;
extern int FrameNum;

class CGLFoundation
{
	public:
		void SetMode(int w, int h, bool fullscreen);
		void Flip();
		void SetScissor(float x1, float y1, float x2, float y2);
		void DisableScissor();
		int GetNumScanlines(float y1, float y2);

	private:
		bool FullScreen;
};

extern CGLFoundation GLFoundation;

/* EXTENSIONS */
extern int GLCapabilities;
extern int GLRectangleTexTarget;

#define GLCAP_COMPRESSED_TEXTURE	0x01
#define GLCAP_NON_POWER_OF_TWO		0x02
#define GLCAP_TEXTURE_RECTANGLE		0x04

#ifndef GL_TEXTURE_RECTANGLE_EXT
#define GL_TEXTURE_RECTANGLE_EXT 0x84F5
#endif
#ifndef GL_TEXTURE_RECTANGLE_ARB
#define GL_TEXTURE_RECTANGLE_ARB 0x84F5
#endif

#endif
