#include "ImageArray.h"
#include <stdio.h>

CImageArray *MaterialArray, *ObjectArray;

CImageArray::CImageArray(char *prototype)
{
	ImageArray = NULL;

	/* find highest valid image */
	char FName[2048];
	NumImages = 0;
	while(1)
	{
		sprintf(FName, "%s%04x.png", prototype, NumImages);
		FILE *t = fopen(FName, "rb");
		if(!t) break;
		fclose(t);
		NumImages++;
	}

	ImageArray = new CBitmap[NumImages];
	int c = NumImages;
	while(c--)
	{
		sprintf(FName, "%s%04x.png", prototype, c);
		ImageArray[c].Load(FName);
	}
}

CImageArray::~CImageArray()
{
	delete[] ImageArray;
}

int CImageArray::GetNumImages()
{
	return NumImages;
}

CBitmap *CImageArray::GetImage(unsigned int index)
{
	if(index < NumImages)
		return &ImageArray[index];
	else
		return NULL;
}
