#ifndef __MAPSEGMENTS_H
#define __MAPSEGMENTS_H

#include <stdlib.h>

#define SEGMENT_LENGTH	600

#define	TILE_MASK	0x3fff
#define	TILE_HFLIP	0x4000
#define TILE_VFLIP	0x8000

struct Object
{
	int ImageId;
	float x, y;

	Object *Next;
};

struct ElevationNode
{
	float y, z;
	float Tangent[2];

	float ArcStart;

	ElevationNode *Next;
};

void EvaluateElevation(ElevationNode *a, ElevationNode *b, float t, float *y, float *z, float *tangent = NULL);

struct CornerNode
{
	float y;
	float Curvature;
	
	/* for editor */
	float scry;

	CornerNode *Next;
};

class MapSegment
{
	public:

		MapSegment();
		~MapSegment();

		void AddObject(Object *);
		bool RemoveObject(Object *);

		void SplitElevationAt(float y);
		void FixElevation();

		void AddCornerNodeAt(float y);
		void FixCorners();

		char Name[33];
		int Next[2], Brother;

		bool Selected;
		unsigned short MaterialMap[SEGMENT_LENGTH][8];
		float StartY; /* bit redundant, but ... */

		Object *ObjList;
		ElevationNode *ElevationList;
		CornerNode *CornerList;

	private:
		float GetArcLength();
};

extern MapSegment Paths[26];

extern void LoadSegments();
extern void SaveSegments();

#endif
