#ifndef __WIDGETS_H
#define __WIDGETS_H

#include "DialogueBase.h"
#include <stdlib.h>

enum OrientationFour {OT_TOPLEFT, OT_BOTTOMRIGHT, OT_TOPRIGHT, OT_BOTTOMLEFT};
enum OrientationTwo {OT_TOP, OT_BOTTOM, OT_LEFT, OT_RIGHT};

class CWidgetBase: public CDialogueBase
{
	public:
		CWidgetBase() {Parent = NULL; id = 0;}
		void SetAction(CDialogueBase *p, int mid) {Parent = p; id  = mid;}
		float Width()	{ return x2-x1; }
		float Height()	{ return y2-y1; }
		virtual void SetPos(float nx1, float ny1, float nx2, float ny2)
		{
			x1 = nx1; y1 = ny1; x2 = nx2; y2 = ny2;
		}
		float Left()	{ return x1; }
		float Right()	{ return x2; }
		float Top()		{ return y1; }
		float Bottom()	{ return y2; }

	protected:
		float x1, y1, x2, y2;
		CDialogueBase *Parent;
		int id;
};

class CButton: public CWidgetBase
{
	public:
		CButton();
		~CButton();

		void SetText(char *);
		void SetPos(float x1, float y1);
		void SizeToFit(OrientationFour o = OT_TOPLEFT);
		void SetActive(bool b);

		bool Message(DialogueMessage *Msg);

	private:
		char *Label;
		bool MouseOver, Active;
};

class CSlider: public CWidgetBase
{
	public:
		CSlider();

		bool Message(DialogueMessage *Msg);

		void SizeToFit(OrientationTwo o = OT_RIGHT);
		void SetPos(float nx1, float ny1, float nx2, float ny2);
		
		float GetValue() {return Value;}
		void SetValue(float v) {Value = v; if(Value < 0) Value = 0; if(Value > 1) Value = 1;}

	private:
		float Value;
		bool Horizontal;
		bool GrabMouse;
};

#endif
